program gwinfo;
{ Written by Hunter Beanland - www.geocities.com/hbeanland }
{$I-} {$G+} {$E+} {$N+} {$V-} {$R-} {$S-}
{$M 8192,0,0}
{
 2.30 replaced pci detect with pcicfg
 2.22 fix nt + only dos detect bug
 2.21 add win2k ver detect
 2.20 fixed amd+33% clock
 2.19 added subvendor ascii name
 2.18 dixon, dmi no info
 2.17 mbd text spacing
 2.16 Copyright and add about
 2.15 Added AMD, SMBIOS read, loosly reordered display. intrum rel.
 2.1  Added external scsi drive detection, ext part read fix.
 2.01 fixed partition size limit -> lba
 2.0  detects >64mb ram, celeron id.
      added controller resets after each id pull-fixes ls120 issue
      removed "translates" from hdd, reworded scsi string
      replace logical fat drives with partition detect.
      added targeted bios id proc.
      report now saves at end, not after every line.
      added onscreen report during detect status
      fixed viewer bugs
 1.14 removed 2000 from Gateway name
 1.13 re-enabled cpu detect. oops
 1.12 fixed port detect, removed joystick - not reliable
 1.1  added inbuilt cpu detect
 1.0  pulled code from gwboot
}
uses
  tools,screen,dos,crt,printer;
const
  ver='v2.30';
  copyright='Copyright 1997-2000';
  prog='== Gateway PC Info ==';
  blank=#13'              '#13;
  cap:WORD=$0279; {Configuration Address Port}
  wdp:WORD=$0A79; {Write Data Port}
  rdp:WORD=$0000; {Read Data Port}
  hexdigits:STRING='0123456789ABCDEF';
  ports: array[0..3] of word = ($1f0,$1f0,$170,$170);
  class: array[0..13] of string[14] = ('Reserved','Disk','Network','Display','Multimedia',
    'Memory','System Bridge','Communications','Peripheral','Input','Docking','CPU','Serial bus','PnP');
  ClassSubCode:array[1..45] of string[4] =('0100','0101','0102','0103','0104','0200',
   '0201','0202','0203','0300','0301','0302','0400','0401','0500','0501',
   '0600','0601','0602','0603','0604','0605','0606','0607',
   '0700','0701','0800','0801','0802','0803','0900','0901','0902',
   '0A00','0B00','0B01','0B02','0B03','0B10','0B40','0C00',
   '0C01','0C02','0C03','0C04');
  ClassSubDesc:array[1..45] of string[13] =('SCSI','IDE','floppy','IPI','RAID','Ethernet',
   'TokenRing','FDDI','ATM','VGA','SuperVGA','XGA','video','audio','RAM','Flash memory',
   'CPU/PCI','PCI/ISA','PCI/EISA','PCI/MCA','PCI/PCI','PCI/PCMCIA','PCI/NuBus','PCI/CardBus',
   'serial','parallel','PIC','DMAC','timer','RTC','keyboard','digitiser','mouse',
   'generic','386','486','Pentium','PentiumP6','Alpha','coproc','Firewire',
   'ACCESS.bus','SSA','USB','Fiber Channel');

VAR serialID,resourceID:ARRAY[1..9] OF BYTE;
    ided,solo,pnpinstalled:BOOLEAN;
    byt,rdpb92:BYTE; {rdp b[9:2]}
    biosmax,appsmax,cardsmax,numberofpnpcards,wy:BYTE;
    cardsid: array[1..250] of string[8];
{    cardspnp: arry[1..20] of string[42];}
    cards: array[1..250] of string[42];
    apps: array[1..2,1..25] of string[18];
    bios: array[1..2,1..50] of string[20];
    scsidrv:array[0..6,1..4] of string[40];
    pci: array[1..20,1..2] of string;
    mmx,mmx2,mmx3,mmx4,mmx5,mmx6,tempw,memseg:word;
{  dword: record
    hiword:word;
    loword:word;
  end;
  int08:procedure;}
  q,l,i,n,maxpci:integer;
  li:longint;
  infile,outfile:text;
  infile2:file;
  dt:datetime;
  regs:registers;
  idstring,filename,line,line2,temp:string;
  windir:string[50];
  search:searchrec;
  found,finished,winrun:boolean;
  h,ad:word;
{  size:real;}
  s1:longint;
  loop : word;
  bios_div, bios_cyl, bios_head, bios_sec : array[0..3] of word;
  dd : array[0..255] of word;
  num_drv,found_drv : byte;
    test8086:byte;
    cputype,cpucat:word;
    stepping,model:byte;
    cpuid_support:boolean;
    vendor_id:string[12];
  endln,linen,tics:integer;
  linebuf:array[1..100] of string[78];
  hline:string;
  erax:string[4];
  erbx:string[4];
  ercx:string[4];
  erdx:string[4];

{************************************************ service procedures ******}
{F+}
{procedure ticc; interrupt;
{$F-}
{begin
  tics:=tics+1;
   if (tics>=18) then begin
    setintvec($08,@int08);
    asm
     mov al,20h
     out 20h,al
    end;
    tics:=0;
    hline:=hline+hline[1];
    delete(hline,1,1);
    window(1,wy-6,80,wy-1);
    write(hline);
    window(1,wy-7,80,wy-2);
    setintvec($08,addr(ticc));
  end;
  inline($9c);
  int08;
end;}

procedure stop(n:integer);    {stops the program with error}
begin
  if paramstr(2)<>'/NOVIEW' then begin
    textmode(3);
    window(1,1,80,25);
  end;
  textattr:=7;
  clrscr;
  Writeln(prog,'  ',ver,'  ',copyright,#10);
  if n<1 then begin
    writeln('Report Saved to: ',fileout);
    halt;
  end;
  write('Error: ');
  case n of
    1: writeln('Reading file ',filein);
    2: writeln('Writing to ',fileout);
    3: writeln('General DOS read/write error');
  end;
  halt(n);
end;

procedure about;
begin
 writeln(prog,'  ',ver,'  ',copyright);
 writeln('Written by Hunter Beanland'#10);
 writeln(#10'Have a nice day :)');
 halt;
end;

procedure openfi(filen:string);  {open file gracefully and prep for errors}
begin
  n:=ioresult;
  assign(infile,filen);
  setfattr(outfile,0);
  n:=doserror;
  filein:=filen;
  reset(infile);
  if ioresult<>0 then stop(1);
end;

procedure openfo(filen:string);  {open file gracefully and prep for errors}
begin
  n:=ioresult;
  assign(outfile,filen);
  setfattr(outfile,0);
  n:=doserror;
  fileout:=filen;
  rewrite(outfile);
  if ioresult<>0 then begin
    assign(outfile,'C:\'+filen);
    fileout:=filen;
    rewrite(outfile);
    if ioresult<>0 then stop(2);
  end;
end;

procedure readini;               {read in the cardid.ini file}
var temp:string;
begin
 line:=paramstr(0);
 line:=copy(line,1,length(line)-3)+'INI';
 openfi(line);
 cardsmax:=1;
 appsmax:=1;
 repeat
  readln(infile,line);
  if ioresult<>0 then stop(1);
  while line[1]=' ' do delete(line,1,1);
  if (line[1] <> ';') and (line<>'') then begin
     temp:=copy(line,1,pos('=',line)-1);
     upstr(temp);
     delete(line,1,pos('=',line));
     if temp='REPORT' then filename:=line;
     if temp='CARDID' then begin
       if cardsmax<251 then begin
        cardsid[cardsmax]:=copy(line,1,pos(',',line)-1);
        delete(line,1,pos(',',line));
        cards[cardsmax]:=line;
        inc(cardsmax);
       end
       else writeln('Too many CARDID');
     end;
     if temp='APP' then begin
       if appsmax<26 then begin
        apps[1,appsmax]:=copy(line,1,pos(',',line)-1);
        delete(line,1,pos(',',line));
        apps[2,appsmax]:=line;
        inc(appsmax);
       end
       else writeln('Too many APPS');
     end;
     if temp='BIOS' then begin
       if biosmax<51 then begin
        bios[1,biosmax]:=copy(line,1,pos(',',line)-1);
        delete(line,1,pos(',',line));
        bios[2,biosmax]:=line;
        inc(biosmax);
       end
       else writeln('Too many BIOS');
     end;
  end;
 until eof(infile);
 close(infile);
 dec(cardsmax);
 dec(appsmax);
 dec(biosmax);
end; {readini}

function readcmos(loc:integer):word;  {read a byte from cmos}
begin
 inline($fa);
 port[$70]:=loc;
 for i:=1 to 10 do;
 readcmos:=port[$71];
 inline($fb);
end;

procedure addline(newline:string);
begin
     if newline<>' ' then writeln(newline);
     inc(endln);
     linebuf[endln]:=newline;  {^}
end;

function num2str(num:longint):string;
var newstr:string;
begin
  str(num,newstr);
  num2str:=newstr;
end;

procedure displn(lnum:integer);
begin
  line:=linebuf[lnum];
  if lnum<3 then begin
    textattr:=15;
    write(line);
    exit;
  end;
  if line[1]<>' ' then textattr:=15
  else textattr:=7;
  write(copy(line,1,pos(':',line)));
  textattr:=7;
  delete(line,1,pos(':',line));
  write(line);
end;

procedure viewfile;  {text viewer}
begin
    window(1,50,80,50);
    textcolor(15); textbackground(1);
    clrscr;
    gotoxy(15,1);
    write('  Use Arrow & Page keys to move, other to exit  ');
    window(1,1,80,49);
    textcolor(7); textbackground(0);
    clrscr;
    i:=49;   endln:=endln+1;
    if endln<i then i:=endln;
    for linen:=1 to i do begin
      gotoxy(1,linen);
      displn(linen);
    end;
    finished:=false;
    linen:=1;
    repeat {until finished}
      ch:=readkey;
      if ch=#0 then begin
       ch:=readkey;
       case ch of
        #73: if linen>1 then begin {pgup}
                   textattr:=7;
                   clrscr;
                   linen:=linen-49;
                   if linen<1 then linen:=1;
                   for i:=0 to 48 do begin
                     gotoxy(1,i+1);
                     displn(linen+i);
                   end;
             end;
        #81: if (linen+49)<=endln then begin {pgdn}
                   textattr:=7;
                   clrscr;
                   linen:=linen+49;
                   if (linen+48)>endln then linen:=endln-48;
                   for i:=0 to 48 do begin
                     gotoxy(1,i+1);
                     displn(linen+i);
                   end;
             end;
        #72,#75: if linen>1 then begin {up,lf}
                   gotoxy(1,1);
                   insline;
                   dec(linen);
                   displn(linen);
                 end;
        #80,#77: if (linen+49)<=endln then begin {dn,rt}
                  gotoxy(1,1);
                  delline;
                  gotoxy(1,49);
                  displn(linen+49);
                  inc(linen);
                 end;
        else exit;
       end; {case}
      end else {not funct}
      if (ch=#80) or (ch=#112) then for i:=1 to endln do writeln(lst,linebuf[i])
      else exit;         {pP}
  until finished;
end;

function searchfile(fname,searchstr:string):boolean;
begin
  findfirst(fname,anyfile,search);
  assign(infile,fname);
  reset(infile);
  if ioresult=0 then begin
   line:='';
   li:=0;
   repeat
    read(infile,ch);
    if ioresult<>0 then begin searchfile:=false; exit; end;
    li:=li+1;
    if length(line)=250 then delete(line,1,1);
    line:=line+ch;
    if pos(searchstr,line)>0 then begin
      delete(line,1,pos(searchstr,line)-1);
      while (li<search.size) and (length(line)<250) do begin
        read(infile,ch);
        li:=li+1;
        line:=line+ch;
      end;
      close(infile);
      searchfile:=true;
      exit;
    end;
   until (li=search.size);
   close(infile);
  end;
  searchfile:=false;
end;

procedure winloc;           {find the windows directory}
var osver:string;
begin
  windir:='';
  osver:='';
  findfirst('C:\MSDOS.SYS',anyfile,search);  {windows 95/98}
  if doserror=0 then begin
   if search.size<5000 then begin
    openfi('C:\MSDOS.SYS');
    while not eof(infile) do begin
     readln(infile,line);
     temp:=line;
     upstr(temp);
     if pos('WINDIR',temp)>0 then begin
       delete(temp,1,pos('=',temp));
       while temp[1]=' ' do delete(temp,1,1);
       while temp[length(temp)]=' ' do delete(temp,length(temp),1);
       windir:=temp;
     end;
    end;
    close(infile);
   end {dos <=6}
   else begin                        {has dos but not win95/98}
    li:=0; finished:=false;
    windir:='C:\Windows';
    findfirst('C:\COMMAND.COM',anyfile,search);
    assign(infile,'C:\COMMAND.COM');
    reset(infile);
    if ioresult=0 then begin
     repeat
      read(infile,ch);
      li:=li+1;
      if ch='V' then begin
       read(infile,ch);
       if ch='e' then begin
        finished:=true;
        read(infile,line);
       end;
      end;
     until ((li=search.size) or (finished));
     line:=copy(line,7,8);
     if line[5]<>'.' then delete(line,8,3);
     osver:=line;
     close(infile);
    end {dos but no win}
    else windir:='5';
   end; {command.com}
  end {msdos.sys}
  else if windir='' then windir:='5';

  findfirst('C:\BOOT.INI',anyfile,search);  {windows nt}
  if doserror=0 then begin
    openfi('C:\BOOT.INI'); finished:=false;
    while (not eof(infile)) and (not finished) do begin
     readln(infile,line);
     temp:=line;
     upstr(temp);
     if (pos('RDISK',temp)>0) and (pos('"',temp)>0) then begin
       windir:=char(ord(temp[pos('RDISK',temp)+18])+18)+':';
       while temp[1]<>'\' do delete(temp,1,1);
       windir:=windir+copy(temp,1,pos('=',temp)-1);
       delete(temp,1,pos('VERS',temp)+7);
       osver:=copy(temp,1,pos('"',temp)-1);
       finished:=true;
     end;
    end;
   close(infile);
  end; {boot.ini}

  finished:=false;                    {windows full ver string}
  if searchfile(windir+'\WINVER.EXE','uctVer') then finished:=true;
  if searchfile(windir+'\SYSTEM32\WINVER.EXE','u'#0'c'#0't'#0'V'#0'e'#0'r') then finished:=true;
  if finished then begin
    for i:=1 to length(line) do
      if (line[i]=#0) then delete(line,i,1);
    line:=copy(line,12,9);
    while ((ord(line[length(line)])<40) or (ord(line[length(line)])>57)) and (line<>'') do
      delete(line,length(line),1);
    osver:=line;
  end {find win ver}
  else begin
    if searchfile('C:\COMMAND.COM','Ver') then begin
      windir:='C:';
      line:=copy(line,10,8);
      if line[5]<>'.' then delete(line,8,3);
      if pos('Vol',line)>0 then line:='?';
      osver:=line;
    end;
  end; {command.com}
  if windir='' then windir:='5';
  {if windir='' then windir:='C:';}
  windir:=windir+'\';
  if windir='5\' then windir:='Not found';
  addline('Windows Directory: '+windir);
  addline('Windows Version: '+osver);
end;

{Include Drives and Cards detection routines}
{$I GWBOOT\GWINFODR.PAS}
{$I GWBOOT\GWINFOCD.PAS}

{CPU detect based on Intel .c detect routines}
{TIME_PROCESSOR_BSF() -- Perform nITERATIONS of the BSF instructions.
 Returns: # of ticks instruction sequence ran. }
{$L timeproc.obj}
function _Time_Processor_bsf:word; far; external;

{ GRABTIME -- Read Time from Counter.
 Returns: Value in PC Chipset Timer. }
function _GrabTime:word; far; external;

procedure CPUIdent;
begin
  test8086:=2;
  mmx:=0;
  cputype:=0;
  cpuid_support:=false;
  vendor_id:='            ';
  {if (Test8086 = 2) then         { RTL check stops at 2 = 386}
  erax:='    ';
  erbx:='    ';
  ercx:='    ';
  erdx:='    ';
  asm
             inc    Test8086     { 3 = 386, for consistency }
    { Do we have a 386 or a 486? }
    { Does pushf/popf preserve the Alignment Check bit? (386=no, 486=yes) }
             mov    bx, sp       { save current stack pointer }
             and    sp, not 3    { align stack to avoid AC fault }
    db $66;  pushf
    db $66;  pop    ax
    db $66;  mov    cx, ax
    db $66, $35; dd $40000       { xor AC bit in EFLAGS }
    db $66;  push   ax
    db $66;  popf
    db $66;  pushf
    db $66;  pop    ax
    db $66;  xor    ax, cx       { Is AC bit toggled? }
             je @@1              { if not, we have a 386 }
             and    sp, not 3    { align stack to avoid AC fault }
    db $66;  push   cx
    db $66;  popf                { restore original AC bit }
             mov    sp, bx       { restore original stack pointer }
             mov  Test8086, 4    { we know we have at least a 486 }

    { Do we have a 486 or a Pentium? }
    { Does pushf/popf preserve the CPUID bit? (486=no, P5=yes) }
    db $66;  mov    ax, cx       { get original EFLAGS}
    db $66, $35; dd $200000      { XOR id bit in flags}
    db $66;  push   ax
    db $66;  popf
    db $66;  pushf
    db $66;  pop    ax
    db $66;  xor    ax, cx      { Is CPUID bit toggled? }
             je @@1             { if not, we have a 486 }
    db $66;  xor    ax, ax
    db $f,$a2                   { CPUID, AX = 0 (get CPUID) }
    db $66;  cmp    ax, 1
             jl @@1             { if < 1, then exit }
    db $66;  xor    ax, ax
    db $66;  inc    ax

    db $f,$a2                   { CPUID, AX = 1 (get CPU info)   }
    mov 	stepping, al
    and	stepping, 0fh
    and 	al, $f0
    shr	al, 4
    mov 	model, al
    and	ax, 0f00h
    shr     ax, 8		   { Isolate family}
    mov     cpucat, ax
    shr     cpucat, 4              {cat= overdrive/sec cpu type}
    and	ax, 0fh
    mov     cputype, ax	           { Set cpu_type with family}
{    mov   mmx2, dx}

    db $66;  xor     ax, ax        { Set up for CPUID instruction}
    db $f,$a2                      { Get and save vendor ID}
    db $66;  mov     word ptr vendor_id[+1], bx
    db $66;  mov     word ptr vendor_id[+5], dx
    db $66;  mov     word ptr vendor_id[+9], cx
    mov cpuid_support, 1           {set to true}
    db $66;  xor    ax, ax
    db $66;  inc    ax
    db $66;  inc    ax
{    db $66;  mov ax, $0002           {get cache sizes}
    db $f,$a2
    db $66;  mov  word ptr erax[+1], ax
    db $66;  mov  word ptr erbx[+1], bx
    db $66;  mov  word ptr ercx[+1], cx
    db $66;  mov  word ptr erdx[+1], dx
{    db $66;  test dx,$00800000
    jz @@1
    mov mmx, dx}
   @@1:
  end;
end;

procedure cpuinfo;
const
 MAXCLOCKS=150;		{ Maximum number of cycles per BSF instruction}
                        {ACCURACY AFFECTING CONSTANTS===}
 ITERATIONS=1500;	{ Number of times to repeat BSF
			{   instruction in samplings.
			{   Initially set to 4000. --1500
			{   NOTE-- Set this value
			{   identically in timeproc.asm}
 SAMPLING_DELAY=500;	{ Number of ticks to allow to
			{   to elapse during sampling.
			{   Initially set to 60.}
 TOLERANCE=2;           { Number of MHz to allow
			{   samplings to deviate from
			{   average of samplings.
			{   Initially set to 2.}
 MAX_TRIES=20;	        { Maximum number of samplings
			{   to allow before giving up
			{   and returning current
			{   average. Initially set to
			{   20.}
 SAMPLINGS=10;	        { Number of BSF sequence
			{   samplings to make.
			{   Initially set to 10.
 	                { Number of MHz above normal-
			{   ised value to normalise
			{   down to the current normalised speed.}
{ Number of cycles needed to execute a single BSF
{   instruction. Note that processors below i386(tm)
{   are not supported.}

processor_cycles:array[0..20] of integer = (
	00,  00,  00, 115, 48, 43,
	38,  38,  38, 38,  38, 38,
	38,  38,  38, 38,  38, 38,
	38,  38,  38);

label jump;
var i:integer;
    u0,u1,v0,v1,t0,t1:word;
    manual,tries:integer;
    current,lowest,ticks,cycles,stamp0,stamp1:longint;
    freq,freq2,freq3,total,aver:longint;
    processor:word;
    ch:char;

begin
  current:= 0;
  lowest:= 2147483647;
  manual:=0;
  freq:=0;
  tries:=0;

  cpuident;            {run external ident procedure}
  processor:=cputype;
  cycles:= longint(iterations) * longint(processor_cycles[processor]);

    if (processor >= 3)  then begin
	if ( processor >= 6 ) then begin
          repeat
                tries:=tries+1;	{ Increment number of times
					{   sampled on this call to
					{   cpuspeed}

		freq3:= freq2;	{ Shift frequencies back to}
		freq2:= freq;	{   make room for new frequency
					{   measurement}
		t0:=_GrabTime;	{ Get Start Time. This code
					{   directly peeks the Counter/
					{   Timer. This tends to cause
					{   inaccuracies on MS-Windows* NT}

                t1:=_GrabTime;  { is multi-processor?- both will say 1}
           if not ((t1=1) and (t0=1)) then begin
		asm	db $f, $31;	{ Read Time Stamp}
	       		MOV CL, 16
			MOV u0, AX
			db $66;	SHR	AX,CL
			MOV u1, AX
    	        end;
	        t1:=t0;
                while ( t1 - t0 < SAMPLING_DELAY ) do
   			 	{ Loop until 500 ticks have passed
    			  	{   since last GrabTime read.
    			  	{   This allows for elapsed time
    			  	{   for sampling}
	    			t1:= _GrabTime;	{ Get End Time}
   	    asm db $f, $31;		{ Read Time Stamp}
		MOV CL, 16
		MOV v0, AX
		db $66;	SHR	AX,CL
		MOV v1, AX
            end;
            stamp0:=  u1*65536 + u0;
   	    stamp1:=  v1*65536 + v0;
				{ Move two 16-bit values into one
				{   32-bit value for the time stamp
				{   read at both the beginning and
				{   end of the test}
      	    cycles:= stamp1 - stamp0;
            ticks:=t1 - t0;
   	    ticks:= ticks * 100000;
        		{ Convert ticks to hundred
			{   thousandths of a tick}
            ticks:=round(ticks/119318);
			{ Convert hundred thousandths of
			{   ticks to microseconds (us)}
	    freq:=round(cycles/ticks);{ Cycles / us  = MHz}
  	    total:= ( freq + freq2 + freq3 );
				{ Total last three frequency
				{   calculations}
            aver:=round(total/3);
            if aver>200 then begin
               i:=aver div 70;   {compensate for overhead}
               aver:=aver+i;
            end;
          end {not multi}
          else begin
            freq:=0;
            aver:=0;
          end;

                until ((tries=max_tries) or ((abs(freq-aver)<tolerance) or (freq=0)
                 or (abs(freq2-aver)<tolerance) or (abs(freq3-aver)<tolerance)));

		freq:=aver;	{ Average last three calculations}
        end {cpu=>6}
        else begin {cpu=386-586}
				{ If processor does not support ring 0
				{   time stamp reading, but is at least
				{   a 386 or above, utilize method of
				{   timing a loop of BSF instructions
				{   which take a known number of cycles
				{   to run on i386(tm), i486(tm), and
				{   Pentium(R) processors.}
		for i:= 1 to SAMPLINGS do begin
				{ Sample Ten times. Can be increased or
				{   decreased depending on accuracy vs.
				{   time requirements}
  		  current:= _Time_Processor_bsf;
		  if ( current < lowest ) then	{ Take lowest elapsed}
 		   lowest:= current;	{   time to account}
					{   for some samplings
					{   being interrupted
					{   by other operations}
		end; {samplings loop}
		ticks:= lowest;
    	        ticks:= ticks * 100000; { Convert ticks to hundred
      		 		    {   thousandths of a tick}
                ticks:=round(ticks/119318);	{ Convert hundred
					{   thousandths of ticks to
					{   microseconds (us) }
       					{ Round up if necessary}
	        freq:=round(cycles/ticks);	{ Cycles / us  = MHz}
        end;  {cpu=386-586}
    end;      {>=386 !clone}

  if cputype=0 then cputype:=test8086;
  line:='CPU: ';
  if vendor_id='GenuineIntel' then
  case cputype of
    5: begin
         line:=line+'Pentium';
         if model>2 then line:=line+' MMX';
       end;
    6: begin
        case model of
         1: line:=line+'Pentium Pro';
      3..6: line:=line+'Pentium II';
{         6: line:=line+'P-II Celeron/Dixon';}
         7: line:=line+'Pentium III';
         8: line:=line+'Pentium III'; {CuMine?}
        end;
       end;
    else line:=line+num2str(cputype)+'86';
  end;
  if vendor_id='AuthenticAMD' then begin
   freq:=0;
   case cputype of
    5: begin
        case model of
      1..5: line:=line+'K5';
       6,7: line:=line+'K6';
         8: line:=line+'K6-2';
         9: line:=line+'K6-3';
        end;
      {  freq:=trunc(freq*0.666); {clocks 33% too high???}
       end;
    6: line:=line+'Athlon K7';
    else line:=line+'AMD type '+num2str(cputype);
   end;
  end;
  if freq>0 then line:=line+' ~'+num2str(freq)+'MHz';
  if cpucat=1 then line:=line+' Overdrive';
  if cpucat=2 then line:=line+' 2nd CPU';
  if cpuid_support then begin
   idstring:=' ';
   temp:=erax+erbx+ercx+erdx;
{   addline(temp);
   for i:=1 to 16 do begin
     s1:=word(temp[i]);
     idstring:=idstring+hex(s1,2);
   end;
     idstring:=idstring+' ';
   for i:=1 to 16 do begin
     write(ord(temp[i]),',');
   end;
   addline(idstring);
   idstring:=' ';}
   if pos('@',temp)>0 then idstring:='0K';
   if pos('A',temp)>0 then idstring:='128K';
   if pos('B',temp)>0 then idstring:='256K';
   if pos('C',temp)>0 then idstring:='512K';
   if pos('D',temp)>0 then idstring:='1M';
   if pos('E',temp)>0 then idstring:='2M';
   if pos('F',temp)>0 then idstring:='4M';
   if idstring<>' ' then line:=line+' '+idstring+'b cache';
   line:=line+' (Model '+num2str(model)+
    ', Stepping '+num2str(stepping)+', "'+vendor_id+'")';
  end;
{  writeln(outfile,'MMX=',mmx,' ',mmx2);}
  addline(line);
end;

procedure smbios;
var fileinfo:searchrec;
    product,serial,mbd,mbdver:string;
const smbiostxt='C:\SHOWALL.TXT';
begin
    addline('System:');
    assign(outfile,smbiostxt);   {test if c: ok to write to}
    rewrite(outfile);
    if ioresult<>0 then exit;
    close(outfile);
    swapvectors;
    exec(getenv('COMSPEC'),'/C GWSHOWAL.EXE > '+smbiostxt);
    swapvectors;
    findfirst(smbiostxt,anyfile,fileinfo);
    if doserror=0 then begin
      temp:='';
      openfi(smbiostxt);
      while not eof(infile) do begin
        readln(infile,line);
        if ioresult<>0 then stop(1);
        temp:=line;
        while (length(temp)>0) and (temp[length(temp)]=' ') do
          delete(temp,length(temp),1);
        delete(temp,1,24);
        if pos('SP',line)=19 then product:=temp;
        if pos('SS',line)=19 then serial:=temp;
        if pos('BM',line)=19 then mbd:=temp;
        if pos('BP',line)=19 then mbd:=mbd+' '+temp;
        if pos('BV',line)=19 then mbdver:=temp;
        if pos('BS',line)=19 then mbdver:=mbdver+', '+temp;
        if pos('CT',line)=19 then
          if temp<>'Unknown' then product:=product+' '+temp;
      end;
      close(infile);
{      assign(infile,smbiostxt);}
      erase(infile);
      if product<>'' then addline(' Type: '+product);
      addline(' Serial: '+serial);
      if mbd<>' ' then begin
        addline(' Motherboard: '+mbd);
        addline('  Ver & sn: '+mbdver);
      end;
    end;
end;

procedure searchdirectory(path:string);
var fileinfo:searchrec;
    i,foundnum:byte;
begin
  findfirst(path+'*.*',anyfile,fileinfo);
  while doserror=0  do  begin
    foundnum:=0;
    upstr(fileinfo.name);
    for i:=1 to appsmax do
      if fileinfo.name=apps[1,i] then foundnum:=i;
    if foundnum>0 then begin
     if length(line)>64 then begin
       addline(line); {copy(line,1,length(line)-2));}
       line:=' ';
     end;
     if (apps[1,foundnum]='IEXPLORE.EXE') then begin
      n:=n+1;                                   {iexplorer is everywhere}
      if n=1 then line:=line+apps[2,foundnum]+', ';
     end else
       line:=line+apps[2,foundnum]+', ';
    end;
    if (fileinfo.attr and directory)=directory then begin
      if (fileinfo.name <> '.') and (fileinfo.name <> '..') then
       searchdirectory(path+fileinfo.name+'\');
    end;
    findnext(fileinfo);
  end;
end;

procedure ioports;
VAR
  comports: array[1..4] of word;
  lptports: array[1..3] of word;
  i,totallpt,totalcom:integer;

BEGIN
  totallpt:=0; totalcom:=0;
  for i:=0 to 3 do begin
    comports[i+1]:=memw[$0040:i*2];
    if comports[i+1]>50 then totalcom:=totalcom+1;
  end;
  for i:=4 to 6 do begin
    lptports[i-3]:=memw[$0040:i*2];
    if lptports[i-3]>50 then totallpt:=totallpt+1;
  end;
  line:='Serial Ports: '+num2str(totalcom)+' (';
  for i:=1 to 4 do
    if comports[i]>50 then
      line:=line+num2str(i)+':'+dec2hex(comports[i],4)+'h, ';
  line:=copy(line,1,length(line)-2);
  if totalcom>0 then line:=line+')';
  addline(line);
  line:='Parallel Ports: '+num2str(totallpt)+' (';
  for i:=1 to 3 do
    if lptports[i]>50 then
      line:=line+num2str(i)+':'+dec2hex(lptports[i],4)+'h, ';
  line:=copy(line,1,length(line)-2);
  if totallpt>0 then line:=line+')';
  addline(line);
{  write(outfile,'Joystick port: ');   {joystick - requires PnP driver}
 { reg.ah:=$84;
  reg.al:=$00;
  reg.dx:=$01;
  intr($15,reg);
  if reg.flags=fcarry then writeln(outfile,'not found')
  else writeln(outfile,'Present');}
end;
{
procedure biosscan(b1,b2,b3:byte);
begin
  q:=0;
  for ad:=0 to $fff0 do
  if (mem[$f000:ad]=b1) and (mem[$f000:ad+1]=b2) and (mem[$f000:ad+2]=b3) then
  begin
    i:=0; if (b1=65) or (b1=80) then n:=1;
    if (b1=83) and (b2=111) then solo:=true;
    line:=' ';
    while ((mem[$f000:ad+i]>31) and (mem[$f000:ad+i]<123)) or (mem[$f000:ad+i]=0) do begin
      if (mem[$f000:ad+i]<>32) and (mem[$f000:ad]<>32) then begin
        line:=line+char(mem[$f000:ad+i]);
        q:=q+1; if q=77 then begin
          q:=0;
          addline(line);
          line:=' ';
        end;
      end;
      i:=i+1;
    end;
    ad:=$fff0;
  end;
end;
}
function ismemloc(address:word; ch:char):boolean;
begin
  if (mem[memseg:address]=ord(ch)) or (mem[memseg:address]=ord(upcase(ch))) then
    ismemloc:=true
  else ismemloc:=false;
end;

function memfind(str:string):boolean;  {string should be lower case}
var prev:boolean;
    scansize:word;
begin
  line:='';
  if memseg=$c000 then scansize:=500
  else scansize:=$fff0;
  for ad:=0 to scansize do begin
    prev:=true;
    for q:=0 to length(str)-1 do
      if not (ismemloc(ad+q,str[q+1]) and prev) then begin
        prev:=false;
        q:=length(str)-1;
      end;
    if prev then begin  {get string}
      q:=0;
      repeat
       if (mem[memseg:ad+q]>31) and (mem[memseg:ad+q]<123) then
         line:=line+char(mem[memseg:ad+q])
       else q:=79;
       q:=q+1;
      until (q=80);
      q:=1;
      repeat
       if (mem[memseg:ad-q]>31) and (mem[memseg:ad-q]<123) then
         insert(char(mem[memseg:ad-q]),line,1)
       else q:=79;
       q:=q+1;
      until (q=80);
      ad:=scansize;
    end;
   end;
  insert(' ',line,1);
  if prev then begin ided:=true; memfind:=true end
  else memfind:=false;
end;

procedure biosid;
var divstr:integer;
begin
 line:='';           {system bios id}
 ided:=false;
 memseg:=$f000;
 for i:=1 to biosmax do begin
  temp:=bios[1,i];
  divstr:=pos('+',temp);
  if divstr>0 then begin
    if (memfind(copy(temp,divstr+1,length(temp)-divstr+1))) and
      (memfind(copy(temp,1,divstr-1))) then addline(' '+bios[2,i]+line);
  end
  else if memfind(temp) then addline('  BIOS: '+bios[2,i]+line);
 end;
 if ided then exit;
{ write('Unknown ');}
 addline('  BIOS:');
 if memfind('phoenix') then addline(line);
 if memfind('ami') then addline(line);
 if memfind('solo') then addline(line);
 if memfind('ver') then addline(line);
 if memfind('rev') then addline(line);
 if memfind('gatew') then addline(line);
 if memfind('bios') then addline(line);
 if memfind('SI$') then addline(line);
end;

{procedure video;
type vesarec=record
  Sig: array [0..3] of Char;
  uVersion: Byte;
  lVersion: Byte;
  Manufacturer: Pointer;
  Flag: longint;
  modes: pointer;
  memory: word;
  swver: word;
  vendor: pointer;
  product: pointer;
  productrev: pointer;
  reserved: array[0..500] of byte;
end;

var buffer: vesarec;
begin
  addline(line);
end;}

procedure readchars(numch:integer);
var ii:integer;
begin
{  if length(line2)=0 then begin
    BlockRead(infile2, line2, 40, ii);
    if ioresult<>0 then stop(1);
  end;}

  for ii:=1 to numch do begin
    read(infile,ch);
    if ioresult<>0 then stop(1);
    if length(line)=40 then delete(line,1,1);
    line:=line+ch;
{    delete(line2,1,1);}
  end;
end;

procedure pids;          {find any product ids/keys}
var fileinfo:searchrec;
begin
  n:=ioresult;
  line:=windir+'\SYSTEM.DAT';
  assign(infile2,line);
  setfattr(infile,0);
  n:=doserror;
  filein:=line;
  reset(infile);
  if ioresult<>0 then begin
    line:=windir+'\SYSTEM32\CONFIG\SYSTEM';
    assign(infile2,line);
    setfattr(infile,0);
    filein:=line;
    reset(infile);
  end;
  findfirst(line,anyfile,search);
  line:=''; line2:='';
  temp:='';  s1:=0;
  write('Scanning PIDs...'#13);
  for li:=1 to search.size do begin
      readchars(1);
{   write(#13,s1);}
      n:=pos('ProductId',line);
      i:=pos('ProductKey',line);
      if (n>0) or (i>0) then begin
          if i>0 then n:=i+1;
          delete(line,1,n+8);
          readchars(n+8);
          n:=1; idstring:='';
          while (ord(line[n])>32) and (ord(line[n])<123) do begin
            idstring:=idstring+line[n];
            n:=n+1;
          end;
          if length(idstring)>22 then temp:=temp+idstring+' ';
      end;
    end;
   close(infile);
   addline('Product ID/Keys: '+temp);
end;

{****************************************************** main *************}
{****************************************************** main *************}
{****************************************************** main *************}

begin
{ hline:=' Scanning ';}
 textattr:=7;
 clrscr;
 if paramcount>0 then line:=paramstr(1);
 upstr(line);
 if pos('ABOUT',line)>0 then about;
 Writeln(prog,'  ',ver,'  ',copyright);
 filename:='GWINFO.TXT';
 cuoff;
 readini;
 if paramcount>0 then filename:=paramstr(1);
 endln:=0;
 writeln('Compiling to ',filename,'. This may take a minute or so...');
 textattr:=128+7;
 for i:=1 to 79 do write('');
{ write(hline);}
 textattr:=7;
{ write(' ');
 for i:=1 to 12 do
   writeln;}
 gotoxy(1,25);
 for i:=1 to 79 do write('');
 window(1,4,80,24);
{ wy:=wherey+1;
 window(1,wy-13,80,wy-2);
{ getintvec($08,@int08);
 setintvec($08,addr(ticc));}
 addline('== System Configuration Report - Created by GWInfo '+ver+' ==');
 addline('at '+ltime+' on '+ldate);
 addline(' ');
 {***************************************************************** system *}
 detectpci;
 smbios;                          {read showall.txt for SMBIOS info}
 biosid;

  cpuinfo;                            {cpu}

{   ad:=0;
    reg.ax:=$8800;
    intr($15,reg);
    ad:=reg.ax;

 addline('16: '+num2str(ad));
 addline('16 bytes '+num2str(reg.al)+','+num2str(reg.ah));

 if (reg.flags and 1)=1 then addline('Error');
{   line:='                   ';
   asm
    mov ax,$8800   {get ext mem size}
{    int $15
    db $66;  mov     word ptr line[+5], ax
   end;
 addline('32-88:'+line+'<');
 li:=(ord(line[+3])*65536)+(ord(line[+2])*256)+ord(line[+1]);
 addline(num2str(li));
 temp:='';
 for i:=1 to 9 do
  temp:=temp+num2str(ord(line[i]))+',';
  addline('32:88 bytes '+temp);
{old   line:='                   ';
   asm
    mov ax,$8881
    int $15
    db $66;  mov     word ptr line[+1], ax
    db $66;  mov     word ptr line[+5], bx
    db $66;  mov     word ptr line[+9], cx
    db $66;  mov     word ptr line[+13], dx
   end;
 addline('32-81:'+line+'<');
 temp:='';
 for i:=1 to 19 do
  temp:=temp+num2str(ord(line[i]))+',';
  addline(temp);
   reg.ax:=$e881;
   intr($15,reg);
   if (reg.ax=$8601) or ((reg.flags and 1)=1) then addline('Error');

  end;
  line:=#01+'                                           ';
  asm
    mov ax, seg line
    push ax
    pop es
    mov di, offset line+1
  end;
  inline($66/$b8/$20/$e8/00/00/$66/$ba/$50/$41/$4d/$53/$66/$bb/00/00/00/00/$66
  /$b9/20/00/00/00);
  asm
    int $15
    db $66; mov mmx,ax
    db $66; mov mmx3,bx
    db $66; mov mmx5,cx
    pushf
    pop ax
    mov ad,ax
  end;
 for i:=1 to 30 do
  temp:=temp+num2str(ord(line[i]))+',';
  addline(num2str(ad)+temp);
  addline(hex(mmx,4)+','+hex(mmx2,4));
  addline(hex(mmx3,4)+','+hex(mmx4,4));
  addline(hex(mmx5,4)+','+hex(mmx6,4));

  line:=#01+'                                           ';
  asm
    mov ax, seg line
    push ax
    pop es
    mov di, offset line+1
  end;
  inline($66/$b8/$20/$e8/00/00/$66/$ba/$50/$41/$4d/$53/$66/$bb/01/00/00/00/$66
  /$b9/20/00/00/00);
  asm
    int $15
    db $66; mov mmx,ax
    db $66; mov mmx3,bx
    db $66; mov mmx5,cx
    pushf
    pop ax
    mov ad,ax
  end;
 for i:=1 to 30 do
  temp:=temp+num2str(ord(line[i]))+',';
  addline(num2str(ad)+temp);
  addline(hex(mmx,4)+','+hex(mmx2,4));
  addline(hex(mmx3,4)+','+hex(mmx4,4));
  addline(hex(mmx5,4)+','+hex(mmx6,4));
}
  intr($12,reg);                      {memory}
  h:=reg.ax;
  ad:=word(256)*readcmos($18)+readcmos($17);
  line:='Memory Size: ';
  s1:=longint(h+ad) div 1024;
  if ad>65000 then begin
   reg.ax:=$e801;
   intr($15,reg);
   if (reg.ax=$8601) or ((reg.flags and 1)=1) then line:=line+'Error, ';
   s1:=longint(reg.bx)*64;
   li:=reg.ax;
   if (s1+li)<65000 then begin
     s1:=longint(reg.dx)*64;
     li:=reg.cx;
   end;
   s1:=(s1+li) div 1024;
  end;
  if odd(s1) then s1:=s1+1;
{  addline(num2str(reg.ax)+' '+num2str(reg.bx)+' '+num2str(reg.cx)+' '+num2str(reg.dx)+' ');}
  addline(line+num2str(s1)+' Mb');
 {*************************************************************** software *}
 addline(' ');
 winloc;
 ad:=filemode; q:=0; n:=0;
 filemode:=0;
 line:='Applications: ';
 write('scanning...'#13);
 searchdirectory('C:\PROGRA~1\');
 if line[length(line)-1]=',' then delete(line,length(line)-1,2);
 addline(line);
 filemode:=ad;
{ if paramstr(2)<>'/QC' then pids;}
  addline(' ');

 {***************************************************************** drives *}

 i:=readcmos($10);                                     {floppy type}
 line:='Floppy Drives: ';
 if i and 240=0 then line:=line+'None';
 if i and 16=16 then line:=line+'360k';
 if i and 48=48 then line:=line+'720k';
 if i and 32=32 then line:=line+'1.2M';
 if i and 64=64 then line:=line+'1.44M';
 if i and 80=80 then line:=line+'2.88M';
 if i and 1=1 then line:=line+' & 360k';
 if i and 3=3 then line:=line+' & 720k';
 if i and 2=2 then line:=line+' & 1.2M';
 if i and 4=4 then line:=line+' & 1.44M';
 if i and 5=5 then line:=line+' & 2.88M';
 addline(line);

{ writeln(outfile,'Hard Drive IDs:');                  {hard drive types}
  num_drv := mem[$0040:$75];
  found_drv:=0;
  addline('Hard Drives: '+num2str(num_drv));
  IdataDrive($1f0,0);
  IdAtaDrive($1f0,1);
  IdAtaDrive($170,2);
  IdAtaDrive($170,3);
{  writeln(outfile);}
  regs.ax:=0;  {reset controller+drives}
  regs.dl:=128;
  intr($13,regs);

  if found_drv<num_drv then begin
{    addline(' Non-IDE drives found: '+num2str(num_drv-found_drv)+' of the '+num2str(num_drv)+' drives may be SCSI');
    inc(found_drv);}
    scsi;
    {for i:=found_drv to num_drv do
      partitions(i);}
  end;
{  addline('Logical FAT Drives:');
  for byt:=3 to 26 do begin
   asm
    mov ah, 36h
    mov dl, byt
    int 21h
    mov h, ax
   end;
   if h<$ffff then begin
     i:=disksize(byt) div 1000000;
     addline(' '+char(byt+64)+': ('+num2str(i)+'Mb)');
   end;
  end;}

  addline('ATAPI CDROM Drives:');      {atapi}
  li:=0;
  idatapidrive($1f0,0);
  idatapidrive($1f0,1);
  idatapidrive($170,0);
  idatapidrive($170,1);
  idatapidrive($1e8,0);
  idatapidrive($1e8,1);
  idatapidrive($168,0);
  idatapidrive($168,1);
  if li=0 then addline(' none ID''ed');
  regs.ax:=0;  {reset controller+drives}
  regs.dl:=128;
  intr($13,regs);

  regs.ax:=$1500;   {get cdrom letter}
  regs.bx:=0;
  intr($2f,regs); {bx=# of cdr drives}
  if regs.bx>0 then addline(' CDROM Drive: '+char(regs.cx+65)+':');
  if regs.bx>1 then addline(' ('+num2str(regs.bx)+' drives in total)');

{ if memfind('solo') then solo:=true
 else solo:=false;
 if not solo then IdentifyPCIDevices;}

  addline('Drive Controllers:');
    for i:=1 to maxpci do
    if copy(pci[i,2],2,1)='1' then addline(' '+pci[i,1]);

  addline(' ');
  addline('Communications:');
    found:=false;
    for i:=1 to maxpci do
    if (copy(pci[i,2],2,1)='2') or (copy(pci[i,2],2,1)='7') then begin
      addline(pci[i,1]);
      found:=true;
    end;
    if not found then addline(' none');
  ioports;

{  intr($11,reg);                              {ports}
 { h:=reg.ax;
  writeln(outfile,#13#10'Serial Ports: ',(h and $0e00) shr 9);
  writeln(outfile,'Parallel Ports: ',(h and $c000) shr 14);


 { port[$201]:=1;
  delay(5);
  found:=false;
  repeat
   if (port[$201] and $f)<>$f then found:=true;
   inc(i);
  until (i=$1000) or found;
  if found then writeln(outfile,' found')
  else writeln(outfile,' not found');}
 {********************************************************** video & sound *}

 addline(' ');
 n:=0;

 addline('Video:');        {video id}
  for i:=1 to maxpci do
    if copy(pci[i,2],2,1)='3' then addline(pci[i,1]);

  memseg:=$c000; ided:=false;
  if memfind('matrox') then addline(' BIOS:'+line);
  if memfind('chromat') then addline(' BIOS:'+line);
  if memfind('ati ') then addline(' BIOS:'+line);
  if memfind('stb') then addline(' BIOS:'+line);
  if memfind('3Dlab') then addline(' BIOS:'+line);
  if memfind('cirrus') then addline(' BIOS:'+line);
  if memfind('nvidia') then addline(' BIOS:'+line);
  if memfind('trident') then addline(' BIOS:'+line);
  if memfind('chips') then addline(' BIOS:'+line);
  if memfind('magicg') then addline(' BIOS:'+line);
  if memfind('silicon') then addline(' BIOS:'+line);
{  if memfind('s3') then addline(line);}
  if not ided then if memfind('ibm') then addline(' BIOS:'+line);

 addline(' ');
 addline('Sound & Multimedia:');        {multimedia/sound id}
    found:=false;
    for i:=1 to maxpci do
    if copy(pci[i,2],2,1)='4' then begin
      addline(pci[i,1]);
      found:=true;
    end;
    if not found then addline(' none');

  addline(' ');

  addline('PnP Cards: ');
{  found:=false;
  for  tempw:=0 to $fffc do begin
  if mem[$f000:tempw]=$24 then
   if mem[$f000:tempw+1]=$50 then
      if mem[$f000:tempw+2]=$6e then
        if mem[$f000:tempw+3]=$50 then begin
          found:=true;
          tempw:=$fffc;
        end;
  end;}
  memseg:=$f000;
  if not memfind('$PnP') then addline(' PnP BIOS not found');
  SelectPnPReadPort(pnpinstalled);
  AssignPNPCSN;
  IdentifyPnPCards;
  addline(' ');
  addline('Other PCI Cards/Devices:');
{  if solo then addline(' notebook PCI devices are not scanned');}
  for i:=1 to maxpci do begin
    line:=copy(pci[i,2],2,1);
    if (line<>'1') and (line<>'2') and (line<>'3') and (line<>'4')
     and (line<>'7') then addline(pci[i,1]);
  end;
{  if not solo then IdentifyPCIDevices
  else addline(' Not scanned - Notebook');}

{  setintvec($08,@int08);}
  openfo(filename);
  writeln('Saving to ',filename,'...');
  for i:=1 to endln do begin
   writeln(outfile,linebuf[i]);
   if ioresult<>0 then stop(2);
  end;
  close(outfile);
{  dispose(linebuf);}
  writeln(' - Done');
 if (paramstr(2)='/QC') or (paramstr(2)='/NOVIEW') then stop(0);
 textmode(lo(3)+256);
 cuoff;
 viewfile;
 stop(0);
end.
